Subject: Re: linux-next: build failure after merge of the driver-core tree

From: Greg KH <[email-masked]>
Date: Mon, 27 Mar 2023 09:33:42 +0200

On Mon, Mar 27, 2023 at 03:46:55PM +1100, Stephen Rothwell wrote:
> Hi all,
> 
> After merging the driver-core tree, today's linux-next build
> (s390-defconfig) failed like this:
> 
> drivers/s390/crypto/ap_bus.c:1596:20: error: initialization of 'ssize_t (*)(const struct bus_type *, char *)' {aka 'long int (*)(const struct bus_type *, char *)'} from incompatible pointer type 'ssize_t (*)(struct bus_type *, char *)' {aka 'long int (*)(struct bus_type *, char *)'} [-Werror=incompatible-pointer-types]
> 
> (reported here: http://kisskb.ellerman.id.au/kisskb/buildresult/14902509/)
> 
> Caused by commit
> 
>   75cff725d956 ("driver core: bus: mark the struct bus_type for sysfs callbacks as constant")
> 
> interacting with commit
> 
>   d7b1813af6a5 ("s390/ap: introduce new AP bus sysfs attribute features")
> 
> from the s390 tree.
> 
> I will apply the following (currently untested) merge fix up patch from
> tomorrow:
> 
> From: Stephen Rothwell <[email-masked]>
> Date: Mon, 27 Mar 2023 15:42:41 +1100
> Subject: [PATCH] fixup for "driver core: bus: mark the struct bus_type for sysfs callbacks as constant"
> 
> interacting with "s390/ap: introduce new AP bus sysfs attribute features"
> 
> Signed-off-by: Stephen Rothwell <[email-masked]>
> ---
>  drivers/s390/crypto/ap_bus.c | 2 +-
>  1 file changed, 1 insertion(+), 1 deletion(-)
> 
> diff --git a/drivers/s390/crypto/ap_bus.c b/drivers/s390/crypto/ap_bus.c
> index 85bb0de15e76..8d6b9a52bf3c 100644
> --- a/drivers/s390/crypto/ap_bus.c
> +++ b/drivers/s390/crypto/ap_bus.c
> @@ -1570,7 +1570,7 @@ static ssize_t bindings_show(const struct bus_type *bus, char *buf)
>  
>  static BUS_ATTR_RO(bindings);
>  
> -static ssize_t features_show(struct bus_type *bus, char *buf)
> +static ssize_t features_show(const struct bus_type *bus, char *buf)

Patch is correct, thank you.

s390 developers, if you have a persistent tag/branch, I can suck this
into the driver core tree and apply this fixup there so that you don't
have to deal with any merge issues for 6.4-rc1 if you want.  Or I can
provide one for you if you need/want that instead.  Or we can just leave
it alone and deal with it during the 6.4-rc1 merge window, your choice.

thanks,

greg k-h